'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _immutable = require('immutable');

var FormCollection = {
  forms: (0, _immutable.Map)({}),
  add: function add(form) {
    this.forms = this.forms.set(form.name, form);
  },
  remove: function remove(name) {
    this.forms = this.forms.delete(name);
  },
  get: function get(name) {
    return this.forms.get(name);
  },
  reset: function reset() {
    this.forms = (0, _immutable.Map)({});
  }
};

exports.default = FormCollection;