'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _FormCollection = require('./FormCollection');

var _FormCollection2 = _interopRequireDefault(_FormCollection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var connectForm = function connectForm(form) {
  return function (Component) {
    var Wrapper = function (_React$Component) {
      _inherits(Wrapper, _React$Component);

      function Wrapper(props, context) {
        _classCallCheck(this, Wrapper);

        var _this = _possibleConstructorReturn(this, (Wrapper.__proto__ || Object.getPrototypeOf(Wrapper)).call(this, props, context));

        _this.state = {
          loaded: false
        };
        return _this;
      }

      _createClass(Wrapper, [{
        key: 'componentDidMount',
        value: function () {
          var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return this.reloadForm(this.props);

                  case 2:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          function componentDidMount() {
            return _ref.apply(this, arguments);
          }

          return componentDidMount;
        }()
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          if (this.unsubscribe && (0, _lodash.isFunction)(this.unsubscribe)) {
            this.unsubscribe();
          }
          _FormCollection2.default.remove(this.form.name);
          this.setState({
            loaded: false
          });
        }
      }, {
        key: 'reloadForm',
        value: function () {
          var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(props) {
            var _this2 = this;

            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    this.form = ((0, _lodash.isFunction)(form) ? form : function () {
                      return form;
                    })(props);
                    this.unsubscribe = this.form.store.subscribe(function () {
                      _this2.forceUpdate();
                    });

                    if (!(0, _lodash.isFunction)(this.form.loadPromise)) {
                      _context2.next = 5;
                      break;
                    }

                    _context2.next = 5;
                    return this.form.load(_extends({}, Component.props, props));

                  case 5:
                    this.setState({
                      loaded: true
                    });

                  case 6:
                  case 'end':
                    return _context2.stop();
                }
              }
            }, _callee2, this);
          }));

          function reloadForm(_x) {
            return _ref2.apply(this, arguments);
          }

          return reloadForm;
        }()
      }, {
        key: 'render',
        value: function render() {
          if (!this.state.loaded) {
            return null;
          }
          var fields = this.form.getFields();
          return _react2.default.cloneElement(Component, _extends({}, this.props, {
            fields: fields,
            form: this.form
          }));
        }
      }]);

      return Wrapper;
    }(_react2.default.Component);

    return Wrapper;
  };
};

exports.default = connectForm;